import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

import { useScroll } from '@use-gesture/react';
import { createBEM } from '@zarm-design/bem';
import * as React from 'react';
import { ConfigContext } from '../config-provider';
import Transition from '../transition';
import { canUseDOM, getMountContainer, getScrollContainer, getScrollTop, renderToContainer, scrollTo } from '../utils/dom';

var BackTop = function BackTop(props) {
  var className = props.className,
      style = props.style,
      visibleDistance = props.visibleDistance,
      destroy = props.destroy,
      onClick = props.onClick,
      children = props.children;

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      visible = _React$useState2[0],
      setVisible = _React$useState2[1];

  var _React$useContext = React.useContext(ConfigContext),
      prefixCls = _React$useContext.prefixCls,
      globalMountContainer = _React$useContext.mountContainer,
      globalScrollContainer = _React$useContext.scrollContainer;

  var bem = createBEM('back-top', {
    prefixCls: prefixCls
  });
  var scrollContainer = React.useMemo(function () {
    var _props$scrollContaine;

    return canUseDOM ? getScrollContainer((_props$scrollContaine = props.scrollContainer) !== null && _props$scrollContaine !== void 0 ? _props$scrollContaine : globalScrollContainer) : undefined;
  }, [props.scrollContainer, globalScrollContainer]);
  var mountContainer = React.useMemo(function () {
    var _props$mountContainer;

    return canUseDOM ? getMountContainer((_props$mountContainer = props.mountContainer) !== null && _props$mountContainer !== void 0 ? _props$mountContainer : globalMountContainer) : undefined;
  }, [props.mountContainer, globalMountContainer]);

  var scrollToTop = function scrollToTop(event) {
    onClick === null || onClick === void 0 ? void 0 : onClick(event);
    if (!scrollContainer) return;
    var scrollTop = getScrollTop(scrollContainer) || 0;
    var speed = props.speed || 0;
    var duration = speed <= 0 || speed === Infinity ? 0 : scrollTop / (speed / 10 * 1000);
    scrollTo(scrollContainer, 0, 0, duration);
  };

  useScroll(function (event) {
    var scrollTop = getScrollTop(event.target) || 0;
    setVisible(scrollTop > visibleDistance);
  }, {
    target: scrollContainer
  });
  React.useEffect(function () {
    var scrollTop = getScrollTop(scrollContainer);
    setVisible(scrollTop > visibleDistance);
  }, [scrollContainer]);
  return renderToContainer(mountContainer, /*#__PURE__*/React.createElement(Transition, {
    visible: visible,
    duration: props.duration,
    destroy: destroy,
    tranisitionName: "".concat(prefixCls, "-fade")
  }, /*#__PURE__*/React.createElement("div", {
    className: bem([className]),
    style: _objectSpread({
      position: mountContainer !== document.body ? 'absolute' : 'fixed'
    }, style),
    onClick: scrollToTop
  }, children)));
};

BackTop.defaultProps = {
  speed: 100,
  visibleDistance: 400,
  destroy: true
};
export default BackTop;