import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

import * as React from 'react';
import { createBEM } from '@zarm-design/bem';
import { ConfigContext } from '../config-provider';
import GridContext from './GridContext';

var Grid = function Grid(props) {
  var className = props.className,
      style = props.style,
      columns = props.columns,
      gutter = props.gutter,
      bordered = props.bordered,
      square = props.square,
      children = props.children;

  var _React$useContext = React.useContext(ConfigContext),
      prefixCls = _React$useContext.prefixCls;

  var bem = createBEM('grid', {
    prefixCls: prefixCls
  });
  var gutters = Array.isArray(gutter) ? gutter : [gutter, gutter];
  var gridContext = React.useMemo(function () {
    return {
      columns: columns,
      gutter: gutters,
      bordered: bordered,
      square: square
    };
  }, [columns, gutters, bordered, square]);
  var gridStyle = {};
  var horizontalGutter = gutters[0] > 0 ? gutters[0] / 2 : undefined;
  var verticalGutter = gutters[1] > 0 ? gutters[1] / 2 : undefined;

  if (!square && horizontalGutter) {
    gridStyle.paddingTop = horizontalGutter;
    gridStyle.paddingBottom = horizontalGutter;
  }

  if (!square && verticalGutter) {
    gridStyle.paddingLeft = verticalGutter;
    gridStyle.paddingRight = verticalGutter;
  }

  var classes = bem([{
    bordered: bordered,
    square: square
  }, className]);
  return /*#__PURE__*/React.createElement(GridContext.Provider, {
    value: gridContext
  }, /*#__PURE__*/React.createElement("div", {
    className: classes,
    style: _objectSpread(_objectSpread({}, gridStyle), style)
  }, children));
};

Grid.displayName = 'Grid';
Grid.defaultProps = {
  columns: 3,
  gutter: 0,
  bordered: true
};
export default Grid;