import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

import * as React from 'react';
import { createBEM } from '@zarm-design/bem';
import { ConfigContext } from '../config-provider';
import GridContext from './GridContext';

var GridItem = function GridItem(props) {
  var className = props.className,
      style = props.style,
      onClick = props.onClick,
      children = props.children;

  var _React$useContext = React.useContext(GridContext),
      columns = _React$useContext.columns,
      gutter = _React$useContext.gutter,
      bordered = _React$useContext.bordered,
      square = _React$useContext.square;

  var _React$useContext2 = React.useContext(ConfigContext),
      prefixCls = _React$useContext2.prefixCls;

  var bem = createBEM('grid-item', {
    prefixCls: prefixCls
  });
  var percent = "".concat(100 / +columns, "%");
  var mergedStyle = {
    flexBasis: percent,
    paddingTop: square ? percent : undefined
  };
  var horizontalGutter;
  var verticalGutter;

  if (!square && gutter && gutter[0] > 0) {
    horizontalGutter = gutter[0] / 2;
    mergedStyle.paddingTop = horizontalGutter;
    mergedStyle.paddingBottom = horizontalGutter;
  }

  if (!square && gutter && gutter[1] > 0) {
    verticalGutter = gutter[1] / 2;
    mergedStyle.paddingLeft = verticalGutter;
    mergedStyle.paddingRight = verticalGutter;
  }

  var cls = bem([{
    clickable: !!onClick,
    'horizontal-bordered': bordered && horizontalGutter > 0,
    'vertical-bordered': bordered && verticalGutter > 0
  }, className]);
  return /*#__PURE__*/React.createElement("div", {
    className: cls,
    style: _objectSpread(_objectSpread({}, mergedStyle), style),
    onClick: onClick
  }, /*#__PURE__*/React.createElement("div", {
    className: bem('content')
  }, children));
};

export default GridItem;