import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

import { mocked } from 'ts-jest/utils';
import ensureValuePrecision from '../../utils/ensureValuePrecision';
import getClosestPoint from '../../utils/getClosestPoint';
import getPrecision from '../../utils/getPrecision';
jest.mock('../../utils/getClosestPoint');
jest.mock('../../utils/getPrecision');
var mGetClosestPoint = mocked(getClosestPoint);
var mGetPrecision = mocked(getPrecision);
describe('ensureValuePrecision', function () {
  var baseProps = {
    min: 0,
    max: 100,
    marks: ''
  };
  afterEach(function () {
    jest.clearAllMocks();
  });
  afterAll(function () {
    jest.resetAllMocks();
  });
  it('should return closest point if it is a finite number and step is 0', function () {
    mGetClosestPoint.mockReturnValue(10);
    var actual = ensureValuePrecision(1, _objectSpread(_objectSpread({}, baseProps), {}, {
      step: 0
    }));
    expect(actual).toEqual(10);
    expect(mGetClosestPoint.mock.calls).toEqual([[1, _objectSpread(_objectSpread({}, baseProps), {}, {
      step: 0
    })], [1, _objectSpread(_objectSpread({}, baseProps), {}, {
      step: 0
    })]]);
  });
  it('should return 0 if closest point is NOT a finite number and step is 0', function () {
    mGetClosestPoint.mockReturnValue(100 / 0);
    var actual = ensureValuePrecision(1, _objectSpread(_objectSpread({}, baseProps), {}, {
      step: 0
    }));
    expect(actual).toEqual(0);
    expect(mGetClosestPoint.mock.calls).toEqual([[1, _objectSpread(_objectSpread({}, baseProps), {}, {
      step: 0
    })]]);
  });
  it('should return closest point number with precision', function () {
    mGetClosestPoint.mockReturnValue(10);
    mGetPrecision.mockReturnValueOnce(2);
    var actual = ensureValuePrecision(1, _objectSpread(_objectSpread({}, baseProps), {}, {
      step: 10
    }));
    expect(actual).toEqual(10);
    expect(mGetClosestPoint.mock.calls).toEqual([[1, _objectSpread(_objectSpread({}, baseProps), {}, {
      step: 10
    })], [1, _objectSpread(_objectSpread({}, baseProps), {}, {
      step: 10
    })]]);
    expect(mGetPrecision).toBeCalledWith(10);
  });
});