import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

import { createBEM } from '@zarm-design/bem';
import { Close, Success } from '@zarm-design/icons';
import * as React from 'react';
import { ConfigContext } from '../config-provider';
import Loading from '../loading';
import Popup from '../popup';
var Toast = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var className = props.className,
      style = props.style,
      icon = props.icon,
      content = props.content,
      duration = props.duration,
      maskStyle = props.maskStyle,
      _props$maskColor = props.maskColor,
      maskColor = _props$maskColor === void 0 ? 'transparent' : _props$maskColor,
      maskClickable = props.maskClickable,
      onClose = props.onClose,
      rest = _objectWithoutProperties(props, ["className", "style", "icon", "content", "duration", "maskStyle", "maskColor", "maskClickable", "onClose"]);

  var _React$useContext = React.useContext(ConfigContext),
      prefixCls = _React$useContext.prefixCls;

  var bem = createBEM('toast', {
    prefixCls: prefixCls
  });

  var renderIcon = function renderIcon() {
    if (icon === undefined || icon === null) return null;

    switch (icon) {
      case 'success':
        return /*#__PURE__*/React.createElement(Success, null);

      case 'fail':
        return /*#__PURE__*/React.createElement(Close, null);

      case 'loading':
        return /*#__PURE__*/React.createElement(Loading, {
          type: "spinner",
          size: "lg"
        });

      default:
        return icon;
    }
  };

  return /*#__PURE__*/React.createElement(Popup, _extends({
    direction: "center",
    maskStyle: _objectSpread({
      pointerEvents: maskClickable ? 'none' : 'auto'
    }, maskStyle),
    maskColor: maskColor,
    lockScroll: !maskClickable,
    className: bem('wrapper')
  }, rest), /*#__PURE__*/React.createElement("div", {
    ref: ref,
    className: bem([{
      icon: !!icon,
      text: !icon
    }, className]),
    style: style
  }, icon && /*#__PURE__*/React.createElement("div", {
    className: bem('icon')
  }, renderIcon()), content && /*#__PURE__*/React.createElement("div", {
    className: bem('text')
  }, content)));
});
export default Toast;