/**
 * 自定义 Hook，用于在非生产环境下对废弃的 props 提示警告。
 * @param {string} componentName - 发生类型变更的组件名称。
 * @param {string} oldProp - 废弃的 prop 名称。
 * @param {string} newProp - 新的 prop 名称。
 */
export declare const useDeprecationWarning: (componentName: any, oldProp: any, newProp: any) => void;
/**
 * 自定义 Hook，用于在非生产环境下对类型变更的 props 提示警告。
 * @param {string} componentName - 发生类型变更的组件名称。
 * @param {string} propName - 发生类型变更的 prop 名称。
 * @param {string} propType - 传入的 prop 类型。
 * @param {string} expectedType - 预期的新类型（如 'object', 'number' 等）。
 */
export declare const useTypeChangeWarning: (condition: any, componentName: any, propName: any, propType: any, expectedType: any) => void;
