"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("@use-gesture/react");

var _bem = require("@zarm-design/bem");

var React = _interopRequireWildcard(require("react"));

var _configProvider = require("../config-provider");

var _transition = _interopRequireDefault(require("../transition"));

var _dom = require("../utils/dom");

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

var BackTop = function BackTop(props) {
  var className = props.className,
      style = props.style,
      visibleDistance = props.visibleDistance,
      destroy = props.destroy,
      onClick = props.onClick,
      children = props.children;

  var _React$useState = React.useState(false),
      _React$useState2 = (0, _slicedToArray2.default)(_React$useState, 2),
      visible = _React$useState2[0],
      setVisible = _React$useState2[1];

  var _React$useContext = React.useContext(_configProvider.ConfigContext),
      prefixCls = _React$useContext.prefixCls,
      globalMountContainer = _React$useContext.mountContainer,
      globalScrollContainer = _React$useContext.scrollContainer;

  var bem = (0, _bem.createBEM)('back-top', {
    prefixCls: prefixCls
  });
  var scrollContainer = React.useMemo(function () {
    var _props$scrollContaine;

    return _dom.canUseDOM ? (0, _dom.getScrollContainer)((_props$scrollContaine = props.scrollContainer) !== null && _props$scrollContaine !== void 0 ? _props$scrollContaine : globalScrollContainer) : undefined;
  }, [props.scrollContainer, globalScrollContainer]);
  var mountContainer = React.useMemo(function () {
    var _props$mountContainer;

    return _dom.canUseDOM ? (0, _dom.getMountContainer)((_props$mountContainer = props.mountContainer) !== null && _props$mountContainer !== void 0 ? _props$mountContainer : globalMountContainer) : undefined;
  }, [props.mountContainer, globalMountContainer]);

  var scrollToTop = function scrollToTop(event) {
    onClick === null || onClick === void 0 ? void 0 : onClick(event);
    if (!scrollContainer) return;
    var scrollTop = (0, _dom.getScrollTop)(scrollContainer) || 0;
    var speed = props.speed || 0;
    var duration = speed <= 0 || speed === Infinity ? 0 : scrollTop / (speed / 10 * 1000);
    (0, _dom.scrollTo)(scrollContainer, 0, 0, duration);
  };

  (0, _react.useScroll)(function (event) {
    var scrollTop = (0, _dom.getScrollTop)(event.target) || 0;
    setVisible(scrollTop > visibleDistance);
  }, {
    target: scrollContainer
  });
  React.useEffect(function () {
    var scrollTop = (0, _dom.getScrollTop)(scrollContainer);
    setVisible(scrollTop > visibleDistance);
  }, [scrollContainer]);
  return (0, _dom.renderToContainer)(mountContainer, /*#__PURE__*/React.createElement(_transition.default, {
    visible: visible,
    duration: props.duration,
    destroy: destroy,
    tranisitionName: "".concat(prefixCls, "-fade")
  }, /*#__PURE__*/React.createElement("div", {
    className: bem([className]),
    style: _objectSpread({
      position: mountContainer !== document.body ? 'absolute' : 'fixed'
    }, style),
    onClick: scrollToTop
  }, children)));
};

BackTop.defaultProps = {
  speed: 100,
  visibleDistance: 400,
  destroy: true
};
var _default = BackTop;
exports.default = _default;