"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _bem = require("@zarm-design/bem");

var _icons = require("@zarm-design/icons");

var _includes = _interopRequireDefault(require("lodash/includes"));

var _react = _interopRequireWildcard(require("react"));

var _button = _interopRequireDefault(require("../button"));

var _configProvider = require("../config-provider");

var _list = _interopRequireDefault(require("../list"));

var _context = require("./context");

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

var getChecked = function getChecked(props, defaultChecked) {
  var _ref, _props$checked;

  return (_ref = (_props$checked = props.checked) !== null && _props$checked !== void 0 ? _props$checked : props.defaultChecked) !== null && _ref !== void 0 ? _ref : defaultChecked;
};

;
var Checkbox = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var inputRef = (0, _react.useRef)(null);

  var _useState = (0, _react.useState)(getChecked(props, false)),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      checked = _useState2[0],
      setChecked = _useState2[1];

  var disabled = props.disabled;
  var groupContext = (0, _react.useContext)(_context.CheckboxGroupContext);

  if (groupContext && props.value !== undefined) {
    checked = (0, _includes.default)(groupContext.value, props.value);

    setChecked = function setChecked(changedChecked) {
      if (changedChecked) {
        groupContext.check(props.value);
      } else {
        groupContext.uncheck(props.value);
      }
    };

    disabled = disabled || groupContext.disabled;
  }

  var _useContext = (0, _react.useContext)(_configProvider.ConfigContext),
      prefixCls = _useContext.prefixCls;

  var bem = (0, _bem.createBEM)('checkbox', {
    prefixCls: prefixCls
  });
  var cls = bem([{
    disabled: disabled,
    checked: checked && !props.indeterminate,
    untext: !props.children,
    indeterminate: props.indeterminate
  }, props.className]);

  var currentProps = _objectSpread(_objectSpread({}, props), {}, {
    checked: checked
  });

  var textRender = props.children && /*#__PURE__*/_react.default.createElement("span", {
    className: bem('text')
  }, props.children);

  var iconRender = /*#__PURE__*/_react.default.createElement("span", {
    className: bem('icon')
  }, props.renderIcon ? props.renderIcon(currentProps) : /*#__PURE__*/_react.default.createElement("span", {
    className: bem('tick')
  }, props.indeterminate ? /*#__PURE__*/_react.default.createElement(_icons.Minus, null) : /*#__PURE__*/_react.default.createElement(_icons.Success, null)));

  var inputRender = /*#__PURE__*/_react.default.createElement("input", {
    ref: inputRef,
    id: props.id,
    type: "checkbox",
    className: bem('input'),
    "aria-checked": checked,
    disabled: disabled,
    value: props.value,
    checked: checked,
    onChange: function onChange(e) {
      var _props$onChange;

      if (disabled) return;

      if (!('checked' in props)) {
        setChecked(e.target.checked);
      }

      (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, e);
    }
  });

  (0, _react.useImperativeHandle)(ref, function () {
    return {
      check: function check() {
        if (checked) return;
        inputRef.current.click();
      },
      uncheck: function uncheck() {
        if (!checked) return;
        inputRef.current.click();
      },
      toggle: function toggle() {
        inputRef.current.click();
      }
    };
  });
  (0, _react.useEffect)(function () {
    if (props.checked === undefined) return;
    if (props.checked === checked) return;
    setChecked(getChecked({
      checked: props.checked,
      defaultChecked: props.defaultChecked
    }, false));
  }, [props.checked, props.defaultChecked]);

  if ((groupContext === null || groupContext === void 0 ? void 0 : groupContext.type) === 'button') {
    return /*#__PURE__*/_react.default.createElement("label", {
      className: cls,
      style: props.style
    }, inputRender, /*#__PURE__*/_react.default.createElement(_button.default, {
      disabled: disabled,
      theme: checked ? 'primary' : 'default',
      size: "xs",
      block: groupContext === null || groupContext === void 0 ? void 0 : groupContext.block,
      onClick: function onClick() {
        inputRef.current.click();
      }
    }, props.children));
  }

  if ((groupContext === null || groupContext === void 0 ? void 0 : groupContext.type) === 'list') {
    var tickRender = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, inputRender, iconRender);

    return /*#__PURE__*/_react.default.createElement(_list.default.Item, {
      hasArrow: false,
      className: cls,
      style: props.style,
      prefix: (groupContext === null || groupContext === void 0 ? void 0 : groupContext.iconAlign) === 'before' ? tickRender : undefined,
      suffix: (groupContext === null || groupContext === void 0 ? void 0 : groupContext.iconAlign) === 'after' ? tickRender : undefined,
      title: textRender,
      onClick: !disabled ? function () {
        if (disabled) return;
        inputRef.current.click();
      } : undefined
    });
  }

  var contentRender = props.render ? props.render(currentProps) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, iconRender, textRender);
  return /*#__PURE__*/_react.default.createElement("label", {
    className: cls,
    style: props.style
  }, inputRender, contentRender);
});
Checkbox.displayName = 'Checkbox';
Checkbox.defaultProps = {
  indeterminate: false
};
var _default = Checkbox;
exports.default = _default;