"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _bem = require("@zarm-design/bem");

var _configProvider = require("../config-provider");

var _GridContext = _interopRequireDefault(require("./GridContext"));

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

var Grid = function Grid(props) {
  var className = props.className,
      style = props.style,
      columns = props.columns,
      gutter = props.gutter,
      bordered = props.bordered,
      square = props.square,
      children = props.children;

  var _React$useContext = React.useContext(_configProvider.ConfigContext),
      prefixCls = _React$useContext.prefixCls;

  var bem = (0, _bem.createBEM)('grid', {
    prefixCls: prefixCls
  });
  var gutters = Array.isArray(gutter) ? gutter : [gutter, gutter];
  var gridContext = React.useMemo(function () {
    return {
      columns: columns,
      gutter: gutters,
      bordered: bordered,
      square: square
    };
  }, [columns, gutters, bordered, square]);
  var gridStyle = {};
  var horizontalGutter = gutters[0] > 0 ? gutters[0] / 2 : undefined;
  var verticalGutter = gutters[1] > 0 ? gutters[1] / 2 : undefined;

  if (!square && horizontalGutter) {
    gridStyle.paddingTop = horizontalGutter;
    gridStyle.paddingBottom = horizontalGutter;
  }

  if (!square && verticalGutter) {
    gridStyle.paddingLeft = verticalGutter;
    gridStyle.paddingRight = verticalGutter;
  }

  var classes = bem([{
    bordered: bordered,
    square: square
  }, className]);
  return /*#__PURE__*/React.createElement(_GridContext.default.Provider, {
    value: gridContext
  }, /*#__PURE__*/React.createElement("div", {
    className: classes,
    style: _objectSpread(_objectSpread({}, gridStyle), style)
  }, children));
};

Grid.displayName = 'Grid';
Grid.defaultProps = {
  columns: 3,
  gutter: 0,
  bordered: true
};
var _default = Grid;
exports.default = _default;