"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _bem = require("@zarm-design/bem");

var _icons = require("@zarm-design/icons");

var _react = _interopRequireWildcard(require("react"));

var _configProvider = require("../config-provider");

var _useLongPress = _interopRequireDefault(require("../use-long-press"));

var _hooks = require("../utils/hooks");

var _BuildInConfig = _interopRequireDefault(require("./BuildInConfig"));

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof3(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

var Keyboard = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var className = props.className,
      style = props.style,
      type = props.type,
      dataSource = props.dataSource,
      onKeyClick = props.onKeyClick,
      restProps = (0, _objectWithoutProperties2.default)(props, ["className", "style", "type", "dataSource", "onKeyClick"]);

  var _useContext = (0, _react.useContext)(_configProvider.ConfigContext),
      globalLocal = _useContext.locale,
      prefixCls = _useContext.prefixCls;

  var locale = globalLocal === null || globalLocal === void 0 ? void 0 : globalLocal.Keyboard;
  var bem = (0, _bem.createBEM)('keyboard', {
    prefixCls: prefixCls
  });
  var cls = bem([className]);
  var getKeyConfig = dataSource || _BuildInConfig.default[type];

  var onKeyPress = function onKeyPress(e, text) {
    e.stopPropagation();
    var keyObj = (0, _typeof2.default)(text) === 'object' ? text : {
      text: text
    };
    var key = keyObj.value || keyObj.text;
    if (!text || keyObj.disabled) return;

    if (typeof onKeyClick === 'function') {
      onKeyClick(key);
    }
  };

  var timerRef = (0, _react.useRef)(0);
  var onKeyPressRef = (0, _hooks.useLatest)(onKeyPress);
  var longPressEvent = (0, _useLongPress.default)({
    // 长按连续删除
    onLongPress: function onLongPress(e) {
      clearInterval(timerRef.current);
      timerRef.current = window.setInterval(function () {
        onKeyPressRef.current(e, 'delete');
      }, 100);
    },
    onPress: function onPress(e) {
      clearInterval(timerRef.current);
      onKeyPressRef.current(e, 'delete');
    },
    onClear: function onClear() {
      return clearInterval(timerRef.current);
    }
  });
  var renderKey = (0, _react.useCallback)(function (text, index) {
    var keyObj = (0, _typeof2.default)(text) === 'object' ? text : {
      text: text
    };
    var commonProps = {
      key: +index,
      className: bem('item', [{
        blank: keyObj.text === '',
        ok: keyObj.text === 'ok',
        disabled: keyObj.disabled
      }]),
      style: {}
    };

    if (keyObj.rowSpan > 1) {
      commonProps.style = _objectSpread(_objectSpread({}, commonProps.style), {}, {
        gridRow: "auto / span ".concat(keyObj.rowSpan),
        height: '100%'
      });
    }

    if (keyObj.colSpan > 1) {
      commonProps.style = _objectSpread(_objectSpread({}, commonProps.style), {}, {
        gridColumn: "auto / span ".concat(keyObj.colSpan)
      });
    }

    var renderText = function renderText() {
      switch (keyObj.text) {
        case 'ok':
          return locale.confirmText;

        case 'delete':
          return /*#__PURE__*/_react.default.createElement(_icons.DeleteKey, {
            size: "lg",
            style: {
              pointerEvents: 'none'
            }
          });

        case 'close':
          return /*#__PURE__*/_react.default.createElement(_icons.Keyboard, {
            size: "lg"
          });

        default:
          return keyObj.text;
      }
    };

    if (keyObj.text === 'delete') return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({}, commonProps, longPressEvent), renderText());
    return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({}, commonProps, {
      onClick: function onClick(e) {
        var _onKeyPressRef$curren;

        return (_onKeyPressRef$curren = onKeyPressRef.current) === null || _onKeyPressRef$curren === void 0 ? void 0 : _onKeyPressRef$curren.call(onKeyPressRef, e, keyObj);
      }
    }), renderText());
  }, []);
  var gridTemplateColumns = Array.from(Array(getKeyConfig.columns).keys()).map(function () {
    return '1fr';
  }).join(' ');
  return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    ref: ref,
    className: cls,
    style: _objectSpread({
      gridTemplateColumns: gridTemplateColumns
    }, style),
    onClick: function onClick(e) {
      e.stopPropagation();
    }
  }, restProps), (getKeyConfig.keys || []).map(renderKey));
});
Keyboard.displayName = 'Keyboard';
Keyboard.defaultProps = {
  type: 'number'
};
var _default = Keyboard;
exports.default = _default;