"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _bem = require("@zarm-design/bem");

var _isFinite = _interopRequireDefault(require("lodash/isFinite"));

var React = _interopRequireWildcard(require("react"));

var _configProvider = require("../config-provider");

var _transition = _interopRequireDefault(require("../transition"));

var _dom = require("../utils/dom");

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

var OpacityList = {
  normal: 0.55,
  light: 0.35,
  dark: 0.75
};
var Mask = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var className = props.className,
      style = props.style,
      visible = props.visible,
      color = props.color,
      opacity = props.opacity,
      animationDuration = props.animationDuration,
      forceRender = props.forceRender,
      destroy = props.destroy,
      afterOpen = props.afterOpen,
      afterClose = props.afterClose,
      onClick = props.onClick,
      children = props.children,
      mountContainer = props.mountContainer;

  var _React$useContext = React.useContext(_configProvider.ConfigContext),
      prefixCls = _React$useContext.prefixCls,
      globalMountContainer = _React$useContext.mountContainer;

  var bem = (0, _bem.createBEM)('mask', {
    prefixCls: prefixCls
  });
  var rgb = color === 'black' ? '0, 0, 0' : '255, 255, 255';
  var backgroundOpacity = (0, _isFinite.default)(opacity) ? opacity : OpacityList[opacity];
  return /*#__PURE__*/React.createElement(_transition.default, {
    nodeRef: ref,
    visible: visible,
    tranisitionName: "".concat(prefixCls, "-fade"),
    duration: animationDuration,
    forceRender: forceRender,
    destroy: destroy,
    onEnter: function onEnter() {
      afterOpen === null || afterOpen === void 0 ? void 0 : afterOpen();
    },
    onLeaveEnd: function onLeaveEnd() {
      afterClose === null || afterClose === void 0 ? void 0 : afterClose();
    }
  }, function (rest, setNodeRef) {
    return (0, _dom.renderToContainer)(mountContainer !== null && mountContainer !== void 0 ? mountContainer : globalMountContainer, /*#__PURE__*/React.createElement("div", {
      ref: setNodeRef,
      className: bem([className, rest.className]),
      style: _objectSpread(_objectSpread(_objectSpread({}, style), rest.style), {}, {
        backgroundColor: color === 'transparent' ? 'transparent' : "rgba(".concat(rgb, ", ").concat(backgroundOpacity, ")")
      }),
      onClick: onClick
    }, children));
  });
});
Mask.displayName = 'Mask';
Mask.defaultProps = {
  visible: false,
  color: 'black',
  opacity: 'normal'
};
var _default = Mask;
exports.default = _default;