"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _bem = require("@zarm-design/bem");

var _configProvider = require("../config-provider");

var _hooks = require("./hooks");

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

var Progress = /*#__PURE__*/_react.default.forwardRef(function (_ref, ref) {
  var _ref2;

  var theme = _ref.theme,
      shape = _ref.shape,
      size = _ref.size,
      percent = _ref.percent,
      strokeShape = _ref.strokeShape,
      text = _ref.text,
      className = _ref.className,
      style = _ref.style,
      children = _ref.children,
      strokeWidth = _ref.strokeWidth,
      htmlAttributes = (0, _objectWithoutProperties2.default)(_ref, ["theme", "shape", "size", "percent", "strokeShape", "text", "className", "style", "children", "strokeWidth"]);
  var progressElement = (0, _react.useRef)(null);

  var _useSizeStyle = (0, _hooks.useSizeStyle)({
    shape: shape,
    size: size
  }),
      sizeStyle = _useSizeStyle.sizeStyle,
      hasKnownSize = _useSizeStyle.hasKnownSize;

  var shouldUseSVG = (0, _hooks.useSVG)({
    shape: shape
  });
  var strokeWidthWithBackup = (0, _hooks.useStrokeWidthWithBackup)({
    strokeWidth: strokeWidth
  });

  var _useSVGStrokeWidth = (0, _hooks.useSVGStrokeWidth)({
    strokeWidth: strokeWidthWithBackup,
    size: size,
    shape: shape,
    progressElement: progressElement,
    shouldUseSVG: shouldUseSVG
  }),
      svgStrokeWidth = _useSVGStrokeWidth.svgStrokeWidth;

  (0, _react.useImperativeHandle)(ref, function () {
    return progressElement.current;
  });
  var finalStrokeWidth = shouldUseSVG ? svgStrokeWidth : strokeWidthWithBackup;

  var _useRoundSVGAttribute = (0, _hooks.useRoundSVGAttributes)({
    shape: shape,
    strokeShape: strokeShape,
    percent: percent,
    finalStrokeWidth: finalStrokeWidth
  }),
      viewBox = _useRoundSVGAttribute.viewBox,
      dasharray = _useRoundSVGAttribute.dasharray,
      strokeLinecap = _useRoundSVGAttribute.strokeLinecap,
      path = _useRoundSVGAttribute.path,
      dashoffset = _useRoundSVGAttribute.dashoffset;

  var _useRectStyles = (0, _hooks.useRectStyles)({
    percent: percent,
    strokeWidthWithBackup: strokeWidthWithBackup,
    finalStrokeWidth: finalStrokeWidth,
    strokeShape: strokeShape
  }),
      lineThumbStyle = _useRectStyles.lineThumbStyle,
      lineTrackStyle = _useRectStyles.lineTrackStyle;

  var indicator = (0, _hooks.useIndicator)({
    percent: percent,
    children: children,
    text: text
  });

  var _React$useContext = _react.default.useContext(_configProvider.ConfigContext),
      prefixCls = _React$useContext.prefixCls;

  var bem = (0, _bem.createBEM)('progress', {
    prefixCls: prefixCls
  });
  var cls = bem([(_ref2 = {}, (0, _defineProperty2.default)(_ref2, "".concat(shape), !!shape), (0, _defineProperty2.default)(_ref2, "".concat(theme), !!theme), (0, _defineProperty2.default)(_ref2, "".concat(size), hasKnownSize), _ref2), className]);

  var roundInner = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("svg", {
    viewBox: viewBox
  }, /*#__PURE__*/_react.default.createElement("path", {
    className: bem('track'),
    d: path,
    strokeWidth: finalStrokeWidth,
    strokeLinecap: strokeLinecap
  }), /*#__PURE__*/_react.default.createElement("path", {
    className: bem('thumb'),
    d: path,
    strokeWidth: finalStrokeWidth,
    strokeLinecap: strokeLinecap,
    strokeDasharray: dasharray,
    strokeDashoffset: dashoffset
  })), indicator && /*#__PURE__*/_react.default.createElement("div", {
    className: bem('text')
  }, indicator));

  var rectInner = /*#__PURE__*/_react.default.createElement("div", {
    className: bem('outer')
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: bem('track'),
    style: lineTrackStyle
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: bem('thumb'),
    style: lineThumbStyle
  })), indicator && /*#__PURE__*/_react.default.createElement("div", {
    className: bem('text')
  }, indicator));

  return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    className: cls,
    style: _objectSpread(_objectSpread({}, sizeStyle), style),
    ref: progressElement
  }, htmlAttributes), shape === 'line' && rectInner, (shape === 'circle' || shape === 'semi-circle') && roundInner);
});

Progress.displayName = 'Progress';
Progress.defaultProps = {
  theme: 'primary',
  shape: 'line',
  size: 'md',
  percent: 0,
  strokeShape: 'round',
  text: function text(val) {
    return "".concat(val, "%");
  }
};
var _default = Progress;
exports.default = _default;