"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SkeletonParagraph = exports.SkeletonTitle = exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _bem = require("@zarm-design/bem");

var _includes = _interopRequireDefault(require("lodash/includes"));

var React = _interopRequireWildcard(require("react"));

var _configProvider = require("../config-provider");

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }

// SkeletonTitle和SkeletonParagraph的shape属性值集合
var SKELETONLINESHAPE = ['radius', 'rect'];

var Skeleton = function Skeleton(props) {
  var _ref;

  var className = props.className,
      shape = props.shape,
      animated = props.animated,
      restProps = (0, _objectWithoutProperties2.default)(props, ["className", "shape", "animated"]);

  var _React$useContext = React.useContext(_configProvider.ConfigContext),
      prefixCls = _React$useContext.prefixCls;

  var bem = (0, _bem.createBEM)('skeleton', {
    prefixCls: prefixCls
  });
  var cls = bem([(_ref = {}, (0, _defineProperty2.default)(_ref, "".concat(shape), !!shape), (0, _defineProperty2.default)(_ref, "animated", animated), _ref), className]);
  return /*#__PURE__*/React.createElement("div", (0, _extends2.default)({
    className: cls
  }, restProps));
};

Skeleton.displayName = 'skeleton';
Skeleton.defaultProps = {
  shape: 'radius'
}; // SkeletonTitle

var SkeletonTitle = function SkeletonTitle(props) {
  var className = props.className,
      shape = props.shape,
      restProps = (0, _objectWithoutProperties2.default)(props, ["className", "shape"]);

  var _React$useContext2 = React.useContext(_configProvider.ConfigContext),
      prefixCls = _React$useContext2.prefixCls;

  var bem = (0, _bem.createBEM)('skeleton', {
    prefixCls: prefixCls
  });
  var cls = bem('title', [className]);

  var _shape = shape && (0, _includes.default)(SKELETONLINESHAPE, shape) ? shape : undefined;

  return /*#__PURE__*/React.createElement(Skeleton, (0, _extends2.default)({
    shape: _shape,
    className: cls
  }, restProps));
}; // SkeletonParagraph


exports.SkeletonTitle = SkeletonTitle;

var SkeletonParagraph = function SkeletonParagraph(props) {
  var className = props.className,
      shape = props.shape,
      _props$lineCount = props.lineCount,
      lineCount = _props$lineCount === void 0 ? 3 : _props$lineCount,
      animated = props.animated,
      restProps = (0, _objectWithoutProperties2.default)(props, ["className", "shape", "lineCount", "animated"]);

  var _React$useContext3 = React.useContext(_configProvider.ConfigContext),
      prefixCls = _React$useContext3.prefixCls;

  var bem = (0, _bem.createBEM)('skeleton', {
    prefixCls: prefixCls
  });
  var cls = bem('paragraph', [className]);
  var lineCls = bem('line');

  var _shape = shape && (0, _includes.default)(SKELETONLINESHAPE, shape) ? shape : undefined;

  return /*#__PURE__*/React.createElement("div", (0, _extends2.default)({
    className: cls
  }, restProps), lineCount > 0 ? Array(lineCount).fill(1).map(function () {
    return /*#__PURE__*/React.createElement(Skeleton, {
      key: arguments.length <= 1 ? undefined : arguments[1],
      shape: _shape,
      animated: animated,
      className: lineCls
    });
  }) : null);
};

exports.SkeletonParagraph = SkeletonParagraph;
var _default = Skeleton;
exports.default = _default;