"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _bem = require("@zarm-design/bem");

var _icons = require("@zarm-design/icons");

var React = _interopRequireWildcard(require("react"));

var _configProvider = require("../config-provider");

var _loading = _interopRequireDefault(require("../loading"));

var _popup = _interopRequireDefault(require("../popup"));

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

var Toast = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var className = props.className,
      style = props.style,
      icon = props.icon,
      content = props.content,
      duration = props.duration,
      maskStyle = props.maskStyle,
      _props$maskColor = props.maskColor,
      maskColor = _props$maskColor === void 0 ? 'transparent' : _props$maskColor,
      maskClickable = props.maskClickable,
      onClose = props.onClose,
      rest = (0, _objectWithoutProperties2.default)(props, ["className", "style", "icon", "content", "duration", "maskStyle", "maskColor", "maskClickable", "onClose"]);

  var _React$useContext = React.useContext(_configProvider.ConfigContext),
      prefixCls = _React$useContext.prefixCls;

  var bem = (0, _bem.createBEM)('toast', {
    prefixCls: prefixCls
  });

  var renderIcon = function renderIcon() {
    if (icon === undefined || icon === null) return null;

    switch (icon) {
      case 'success':
        return /*#__PURE__*/React.createElement(_icons.Success, null);

      case 'fail':
        return /*#__PURE__*/React.createElement(_icons.Close, null);

      case 'loading':
        return /*#__PURE__*/React.createElement(_loading.default, {
          type: "spinner",
          size: "lg"
        });

      default:
        return icon;
    }
  };

  return /*#__PURE__*/React.createElement(_popup.default, (0, _extends2.default)({
    direction: "center",
    maskStyle: _objectSpread({
      pointerEvents: maskClickable ? 'none' : 'auto'
    }, maskStyle),
    maskColor: maskColor,
    lockScroll: !maskClickable,
    className: bem('wrapper')
  }, rest), /*#__PURE__*/React.createElement("div", {
    ref: ref,
    className: bem([{
      icon: !!icon,
      text: !icon
    }, className]),
    style: style
  }, icon && /*#__PURE__*/React.createElement("div", {
    className: bem('icon')
  }, renderIcon()), content && /*#__PURE__*/React.createElement("div", {
    className: bem('text')
  }, content)));
});
var _default = Toast;
exports.default = _default;