"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.config = exports.clear = exports.show = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _isPlainObject = _interopRequireDefault(require("lodash/isPlainObject"));

var _isString = _interopRequireDefault(require("lodash/isString"));

var React = _interopRequireWildcard(require("react"));

var _dom = require("../utils/dom");

var _Toast = _interopRequireDefault(require("./Toast"));

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

var currentHandler = null;
var currentTimer = null;
var defaultProps = {
  duration: 2000,
  mask: true,
  maskClickable: true
};

var show = function show(props) {
  var rest = _objectSpread(_objectSpread({}, defaultProps), (0, _isString.default)(props) ? {
    content: props
  } : props);

  var element = /*#__PURE__*/React.createElement(_Toast.default, (0, _extends2.default)({}, rest, {
    onClose: function onClose() {
      currentHandler = null;
    }
  }));

  if (currentHandler) {
    currentHandler.replace(element);
  } else {
    currentHandler = (0, _dom.renderImperatively)(element);
  }

  currentTimer && window.clearTimeout(currentTimer);

  if (rest.duration !== 0) {
    currentTimer = window.setTimeout(function () {
      clear();
    }, rest.duration);
  }

  return currentHandler;
};

exports.show = show;

var clear = function clear() {
  var _currentHandler;

  (_currentHandler = currentHandler) === null || _currentHandler === void 0 ? void 0 : _currentHandler.close();
  currentHandler = null;
};

exports.clear = clear;
var ALLOW_KEYS = ['duration', 'mask', 'maskClassName', 'maskStyle', 'maskColor', 'maskOpacity', 'maskClickable', 'mountContainer'];

var config = function config(props) {
  if (!(0, _isPlainObject.default)(props)) return;
  Object.entries(props).forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray2.default)(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    if (ALLOW_KEYS.indexOf(key) === -1) return;

    if (value !== undefined) {
      defaultProps[key] = value;
    }
  });
};

exports.config = config;