"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _bem = require("@zarm-design/bem");

var _react = _interopRequireWildcard(require("react"));

var _configProvider = require("../config-provider");

var _popper = _interopRequireDefault(require("../popper"));

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }

var Tooltip = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var children = props.children,
      content = props.content,
      className = props.className,
      others = (0, _objectWithoutProperties2.default)(props, ["children", "content", "className"]);

  var _React$useContext = _react.default.useContext(_configProvider.ConfigContext),
      prefixCls = _React$useContext.prefixCls;

  var bem = (0, _bem.createBEM)('tooltip', {
    prefixCls: prefixCls
  });
  var cls = bem([className]);
  var poperRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      update: function update() {
        var _poperRef$current;

        return (_poperRef$current = poperRef.current) === null || _poperRef$current === void 0 ? void 0 : _poperRef$current.update();
      }
    };
  });
  return /*#__PURE__*/_react.default.createElement(_popper.default, (0, _extends2.default)({
    content: content,
    className: cls
  }, others, {
    ref: poperRef
  }), children);
});
Tooltip.defaultProps = {
  direction: 'top',
  hasArrow: true,
  onVisibleChange: function onVisibleChange() {}
};
var _default = Tooltip;
exports.default = _default;