"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _includes = _interopRequireDefault(require("lodash/includes"));

var _events = _interopRequireDefault(require("../utils/events"));

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }

var Trigger = function Trigger(props) {
  var visible = props.visible,
      onClose = props.onClose,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled; // execute callback function, KeyboardEvent.keycode was not recommended in MDN.

  var onKeydown = function onKeydown(e) {
    if (e.code === 'Escape') {
      var lens = Trigger.instanceList.length;
      var last = Trigger.instanceList[lens - 1];

      if (last) {
        !last.disabled && last();
      }
    }
  };

  (0, _react.useEffect)(function () {
    onClose && (onClose.disabled = disabled);

    if (visible === true && typeof onClose === 'function') {
      if (!(0, _includes.default)(Trigger.instanceList, onClose)) {
        Trigger.instanceList.push(onClose);
      }
    } else {
      var index = Trigger.instanceList.findIndex(function (c) {
        return c === onClose;
      });

      if (index > -1) {
        Trigger.instanceList.splice(index, 1);
      }
    }
  }, [visible, disabled, onClose]);
  (0, _react.useEffect)(function () {
    // In the case of multiple Trigger Components, only execute addEventlistener just for once.
    if (Trigger.count === 0) {
      _events.default.on(document.body, 'keydown', onKeydown);
    }

    Trigger.count += 1;
    return function () {
      var index = Trigger.instanceList.findIndex(function (c) {
        return c === onClose;
      });

      if (index > -1) {
        Trigger.instanceList.splice(index, 1);
      }

      Trigger.count -= 1;

      if (Trigger.count === 0) {
        _events.default.off(document.body, 'keydown', onKeydown);
      }
    };
  }, []);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, props.children);
};

Trigger.defaultProps = {
  visible: false,
  disabled: false
};
Trigger.instanceList = [];
Trigger.count = 0;
var _default = Trigger;
exports.default = _default;