"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isFunction = _interopRequireDefault(require("lodash/isFunction"));

var React = _interopRequireWildcard(require("react"));

var _dom = require("../../dom");

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) { if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } } return n.default = e, t && t.set(e, n), n; }

var totalLockCount = 0;
var originalOverflow = _dom.canUseDOM ? document.body.style.overflow : '';

var useLockScroll = function useLockScroll(shouldLock) {
  var lock = function lock() {
    if (!totalLockCount) {
      document.body.style.overflow = 'hidden';
    }

    totalLockCount += 1;
  };

  var unlock = function unlock() {
    if (!totalLockCount) return;
    totalLockCount -= 1;

    if (!totalLockCount) {
      document.body.style.overflow = originalOverflow || '';
    }
  };

  React.useEffect(function () {
    if ((0, _isFunction.default)(shouldLock) ? shouldLock() : shouldLock) {
      lock();
      return unlock;
    }
  }, [shouldLock]);
};

var _default = useLockScroll;
exports.default = _default;